Subject: Re: [0/14] GRO: Lots of microoptimisations

From: Benjamin LaHaise <[email-masked]>
Date: Fri, 12 Jun 2009 12:09:26 -0400

On Wed, Jun 10, 2009 at 03:44:49PM +1000, Herbert Xu wrote:
> On Fri, May 29, 2009 at 12:23:13PM -0400, Benjamin LaHaise wrote:
> >
> > It's just being turned off by setting a loadable module option.
> 
> Let me see if I can get my hands on a machine with your NIC.

I found at least one reason why: the first skb_shinfo()->frag_list touch 
in dev_gro_receive() was causing a cache miss.  Adding a prefetch in the 
driver helps that a little bit, but there's still > 500Mbps difference.  
I'd like to retest on a system with newer CPUs, but it will probably be a 
few weeks until all the hardware is in the same place.

		-ben